<?php
/**
 * 订单催发货(店小蜜)
 * 
 * @author wangbiao<wangbiao@shopex.cn>
 * @version 0.1
 */
class erpapi_shop_response_delivergoods extends erpapi_shop_response_abstract
{
    /**
     * 接收参数
     */
    public $_sdf = array();
    
    /**
     * 催发货
     * 
     * @param array $params
     * @return array
     */
    public function urgent($params){
        $this->__apilog['title'] = '催发货';
        
        $params = $this->_returnParams($params);
        if(empty($params)){
            $this->__apilog['result']['msg'] = '催发货: 该平台不支持催发货';
            return false;
        }
        
        $this->__apilog['original_bn'] = $params['order_bn'];
        $this->__apilog['result']['data'] = $params;
        
        if(empty($params)) {
            $this->__apilog['result']['msg'] = '催发货: 没有可处理的订单!';
            return false;
        }
        
        //检查订单
        $orderObj = app::get('ome')->model('orders');
        $this->_sdf = $orderObj->dump(array('order_bn'=>$params['order_bn']), 'order_id, order_bn, process_status, status, ship_status');
        if(empty($this->_sdf)){
            $this->__apilog['result']['msg'] = '催发货: 订单不存在!';
            return false;
        }
        
        if($this->_sdf['status'] == 'dead'){
            $this->__apilog['result']['msg'] = '催发货: 订单已作废,不能催发货!';
            return false;
        }
        
        return $this->_sdf;
    }
    
    /**
     * 获取数据
     * 
     * @param array $params
     * @return array:
     */
    protected function _returnParams($params) {
        return array();
    }
    
    /**
     * 格式化参数
     *
     * @param array $params
     * @return array:
     */
    protected function _formatParams($params) {
        $sdf = array('order_bn'=>$params['tid']);
        
        return $sdf;
    }
}
