<?php
/**
 * 自助开发票(店小蜜)
 * 
 * @author wangbiao<wangbiao@shopex.cn>
 * @version 0.1
 */
class erpapi_shop_response_invoice extends erpapi_shop_response_abstract
{
    /**
     * 接收参数
     */
    public $_sdf = array();
    
    /**
     * 自助开发票
     * 
     * @param array $params
     * @return array
     */
    public function add($params){
        $this->__apilog['title'] = '自助开发票';
        
        //format params
        $params = $this->_returnParams($params);
        if(empty($params)){
            $this->__apilog['result']['msg'] = '自助开发票: 该平台不支持自助开发票';
            return false;
        }
        
        $this->__apilog['original_bn'] = $params['order_bn'];
        $this->__apilog['result']['data'] = $params;
        
        if(empty($params['order_bn'])) {
            $this->__apilog['result']['msg'] = '自助开发票: 没有可开发票的订单!';
            return false;
        }
        
        //检查订单
        $orderObj = app::get('ome')->model('orders');
        $this->_sdf = $orderObj->dump(array('order_bn'=>$params['order_bn']), 'order_id, order_bn, is_tax, ship_name, ship_area, ship_addr, ship_zip, ship_tel, ship_email, ship_mobile');
        if(empty($this->_sdf)){
            $this->__apilog['result']['msg'] = '自助开发票: 订单不存在!';
            return false;
        }
        
        if($this->_sdf['status'] == 'dead'){
            $this->__apilog['result']['msg'] = '自助开发票: 订单已作废,不能开票!';
            return false;
        }
        
        $this->_sdf = array_merge($this->_sdf, $params);
        
        return $this->_sdf;
    }
    
    /**
     * 获取数据
     * 
     * @param array $params
     * @return array:
     */
    protected function _returnParams($params) {
        return array();
    }
    
    /**
     * 格式化参数
     *
     * @param array $params
     * @return array:
     */
    protected function _formatParams($params) {
        
        //订单号
        $order_bn = $params['tid'];
        
        //发票属性(0:公司；1：个人)
        $invoice_attr = ($params['invoice_attr'] == '1' ? 1 : 0);
        
        //发票类型（1:普通发票；2：增值税专用发票）
        $invoice_type = ($params['invoice_type'] == '2' ? 2 : 1);
        
        //发票形态 （1:电子发票; 2：纸质发票)
        $invoice_kind = ($params['invoice_kind'] == '2' ? 2 : 1);
        
        //公司发票抬头
        $company_title = $params['company_title'];
        
        //公司发票税号
        $tax_no = $params['tax_no'];
        
        //增值税扩展参数(registered_address注册地址、registered_phone注册电话、bank开户行、bank_account账户)
        $extend_arg = ($params['extend_arg'] ? json_decode($params['extend_arg'], true) : '');
        
        //组织数据
        $sdf = array(
                'order_bn' => $order_bn,
                'invoice_attr' => $invoice_attr,
                'invoice_kind' => $invoice_kind,
                'company_title' => $company_title,
                'tax_no' => $tax_no,
                'invoice_type' => $invoice_type,
                'extend_arg' => $extend_arg,
        );
        
        return $sdf;
    }
}
