<?php
/**
 * 订单催发货
 * 
 * @author wangbiao<wangbiao@shopex.cn>
 * @version 0.1
 */
class erpapi_shop_response_process_delivergoods extends erpapi_shop_response_abstract
{
    public function urgent($order)
    {
        //已发货,接口返回成功
        if($order['ship_status'] == '1'){
            return array('rsp'=>'succ','msg'=>'催发货: 订单已发货,不能催发货!');
        }
        
        //更新订单为"催发货"状态
        $orderObj = app::get('ome')->model('orders');
        $result = $orderObj->update(array('order_bool_type'=>ome_order_bool_type::__URGENT_DELIVERY), array('order_id'=>$order['order_id']));
        if(!$result){
            return array('rsp'=>'fail', 'msg'=>'催发货: 订单更新为催发货,失败!');
        }
        
        //日志
        $memo = '催发货: 买家催发货';
        app::get('ome')->model('operation_log')->write_log('order_modify@ome', $order['order_id'], $memo);
        
        return array('rsp'=>'succ','msg'=>'催发货: 订单更新为催发货成功!');
    }
}
