<?php
/**
 * 自助开发票
 * 
 * @author wangbiao<wangbiao@shopex.cn>
 * @version 0.1
 */
class erpapi_shop_response_process_invoice extends erpapi_shop_response_abstract
{
    public function add($order)
    {
        //检查是否已开票
        $invoiceInfo = array();
        if($order['is_tax'] == 'true'){
            $invoiceObj = app::get('invoice')->model('order');
            $invoiceInfo = $invoiceObj->dump(array('order_id'=>$order['order_id'], 'is_status'=>array('0', '1')), '*');
            
            //已完成开票,返回失败
            if($invoiceInfo['is_status'] == '1'){
                return array('rsp'=>'fail', 'msg'=>'自助开发票: 订单已经开过发票,不能重复开票!');
            }
        }
        
        //发票抬头
        if($order['invoice_attr']===1 && $order['company_title']==''){
            $order['company_title'] = '个人';
        }
        
        //save
        $invoiceLib = kernel::single('invoice_process');
        if($invoiceInfo && $invoiceInfo['is_status'] == '0'){
            //更新开票信息
            $params = array(
                    'id' => $invoiceInfo['id'], //更新的发票记录ID
                    'order_id' => $order['order_id'],
                    'mode' => ($order['invoice_kind']==1 ? 1 : 0), //开票方式(0纸质发票、1电子发票)
                    'title' => $order['company_title'],
                    'ship_bank' => $order['extend_arg']['bank'], //客户开户银行
                    'ship_bank_no' => $order['extend_arg']['bank_account'], //客户银行账号
                    'business_type' => ($order['invoice_attr']==1 ? 0 : 1), //客户类型(0个人、1企业)
                    'ship_tax' => $order['tax_no'], //客户税号
                    'tax_company' => $order['consignee']['name'],
                    'ship_tel' => $order['consignee']['mobile'] ? $order['consignee']['mobile'] : $order['consignee']['telephone'],
                    'ship_area' => $order['consignee']['area'],
                    'ship_addr' => $order['consignee']['addr'],
                    'type_id' => ($order['invoice_type']==2 ? 1 : 0), //发票类型(0普通发票、1专业发票)
                    
                    'tax_no' => $invoiceInfo['tax_no'], //开票方税号
                    'bank' => $invoiceInfo['bank'], //开票方银行
                    'bank_no' => $invoiceInfo['bank_no'], //开票方银行账号
                    'tax_rate' => $invoiceInfo['tax_rate'], //税率
                    'content_id' => $invoiceInfo['content_id'],
                    'remarks' => $invoiceInfo['remarks'],
                    'payee_name' => $invoiceInfo['payee_name'],
                    'address' => $invoiceInfo['address'], //开票方地址
                    'telephone' => $invoiceInfo['telephone'], //开票方电话
                    'payee_operator' => $invoiceInfo['payee_operator'], 
            );
            
            //订单总金额
            $params['amount'] = number_format($order['total_amount'], 2, ".", "");
            
            //发票税金
            $params['cost_tax'] = number_format(($order['total_amount'] * $params['tax_rate'])/100, 2, ".", "");
            
            $result = $invoiceLib->edit($params);
            if(!$result){
                return array('rsp'=>'succ','msg'=>'自助开发票: 更新订单开票失败!');
            }
        }else{
            //添加开票
            $params = array(
                    'order_id' => $order['order_id'],
                    'order_bn' => $order['order_bn'],
                    'consignee' => $order['consignee'], //收货人信息(name, mobile, telephone, area, addr)
                    
                    'business_type' => ($order['invoice_attr']==1 ? 0 : 1), //客户类型(0个人、1企业)
                    'type_id' => ($order['invoice_type']==2 ? 1 : 0), //发票类型(0普通发票、1专业发票)
                    'invoice_mode' => ($order['invoice_kind']==1 ? 1 : 0), //开票方式(0纸质发票、1电子发票)
                    'tax_title' => $order['company_title'], //发票抬头
                    'ship_tax' => $order['tax_no'], //税号
                    
                    'ship_bank'=>$order['extend_arg']['bank'], //客户开户银行
                    'ship_bank_no'=>$order['extend_arg']['bank_account'], //客户银行账号
                    'registered_address'=>$order['extend_arg']['registered_address'], //注册地址
                    'registered_phone'=>$order['extend_arg']['registered_phone'], //注册电话
            );
            $result = $invoiceLib->create($params, 'dianxiaomi');
            if(!$result){
                return array('rsp'=>'succ','msg'=>'自助开发票: 订单开票失败!');
            }
            
            //更新订单为开票状态
            $orderObj = app::get('ome')->model('orders');
            $orderObj->update(array('is_tax'=>'true'), array('order_id'=>$order['order_id']));
        }
        
        //日志
        $memo = '买家要求开票,发票抬头: '. $order['company_title'];
        app::get('ome')->model('operation_log')->write_log('order_modify@ome', $order['order_id'], $memo);
        
        //return
        return array('rsp'=>'succ','msg'=>'自助开发票: 订单开发票成功!');
    }
}
